import Kplot

class Device(Kplot.DeviceAbstract):
	def __init__(self, size=(150,150), units=None):
		Kplot.DeviceAbstract.__init__(self)
		mm = Kplot.Vector(150, 150)
		self.dimensions["mm"] = mm
		self.changeSize(size, units)
		self.opened = False
		self.open()
		self.changeSize(size, units)

	def getDeviceMatrix(self):
		return Kplot.Matrix()

	def _plotPolyline(self, x, y, linestyle, linewidth, color, units):
		pass

	def plotLines(self, x, y, linestyle, linewidth, color, units):
		pass

	def _plotPolygon(self, x, y, linestyle, fillstyle, linewidth, color, units):
		pass

	def _plotText(self, text, location, font, fontsize, weight, color, bgcolor, textangle, valign, halign, units):
		pass

	def plotImage(self, data, colormap, datamin, datamax, function):
		pass

	def clear(self):
		pass

	def changeSize(self, size, units=None):
		matrix = self.getUnitMatrix("mm").inverse() * self.getUnitMatrix(units)
		mm = matrix * size
		cm = mm.scale(0.1)
		inch = cm.scale(1/2.54)
		points = inch.scale(72)
		self.dimensions["mm"] = mm
		self.dimensions["cm"] = cm
		self.dimensions["inch"] = inch
		self.dimensions["points"] = points
		self.dimensions["mm"] = mm

	def open(self):
		assert(not self.opened)
		self.opened = True

	def close(self):
		assert(self.opened)
		self.opened = False

	def getLinestyles(self):
		return ["noline", "normal", "dotted", "dashed"]

	def getFillstyles(self):
		return ["nofill", "solid", "hatched", "crosshatched"]

	def getFonts(self):
		return ["normal", "roman", "italic"]

	def setBgColor(self, color):
		pass

	def setFgColor(self, color):
		pass

