#!/usr/bin/env python

class ColorTable:
	def __init__(self, startColor, endColor):
		self.startColor = startColor
		self.endColor = endColor
		self.colors = []

	def overlaps(self, colormap):
		return	(colormap.startColor <= self.endColor and colormap.endColor >= self.startColor)

	def findIndex(self, color):
		#for c in self.colors:
		index = None
		if color in self.colors:
			index = self.startColor + self.colors.index(color)
		return index

	def isFull(self):
		return not ( len(self.colors) < ((self.endColor - self.startColor) + 1) )

	def addColor(self, color, ppgplot):
		if self.findIndex(color) == None:
			if len(self.colors) < ((self.endColor - self.startColor) + 1):
				index = self.startColor + len(self.colors)
				self.colors.append(color)
				ppgplot.pgscr(index,color.r, color.g, color.b)
				return index
				#print "setting color:", index, "to", color
			else:
				raise Exception, "can't add color, ColorTable is full"

	def getClosest(self, color):
		if len(self.colors) == 0:
			return None
		if len(self.colors) == 1:
			return self.colors[0]
		bestColor = self.colors[0]
		distance = bestColor.distance(color)
		#length = len(self.colors)
		#for i in range(2, length):
		for c in self.colors:
			newDistance = c.distance(color)
			if newDistance < distance:
				bestColor = c
				distance = newDistance
		return bestColor

	def installColors(self, ppgplot):
		for i in range(self.startColor, self.endColor + 1):
			color = self.colors[i]
			ppgplot.pgscr(i,color.r, color.g, color.b)



"""
Color = ezplot.const.Color
red = Color(255, 0, 0)
green = Color(0, 255, 0)
blue = Color(0, 0, 255)
white = Color(255, 255, 255)

cm1 = Colormap(1, 200)
cm2 = Colormap(4, 6)
cm3 = Colormap(7, 17)
print cm1.overlaps(cm2)
print cm2.overlaps(cm1)
print cm3.overlaps(cm2)
print cm2.overlaps(cm3)
print cm3.overlaps(cm1)
print cm1.overlaps(cm3)
cm = ColormapLinear(Color(0,0,0), Color(255,128,0), 50, 100)

#cm.addColor(red)
#cm.addColor(green)
#cm.addColor(blue)
#cm.addColor(Color(128, 128, 99))
#cm.addColor(Color(128, 128, 96))
#cm.addColor(white)
closest = cm.getClosest(Color(18, 128, 97))
print closest
print cm.findIndex(closest)
"""
