"""PlotObjects for Kplot

This package consists mainly of subclasses of PlotObject
Each PlotObject can be used as the example in the Kplot main package.
They all have an example method, that should give you and idea what
the PlotObjects is, and can do.

>>> import Kplot
>>> Kplot.Line.example()
Line example

Line is a very simple plotobject.
It just needs two points:
line = Kplot.Line((-1, -1, (1, 2))

 Type <RETURN> for next page:

Line also has a few properties which can be altered
for instance: line.linestyle="dotted"
for more propeties see help(Line)
 Type <RETURN> for next page:
>>>


Instead of the createDevice() you create your own device.


this is what you can find in the Kplot.plotpackage package:
basic : Polyline, Polygon, Text, Image, Contours
nonbasic : Line, Marker, Markers, Circle, Rectangle
compound : MarkerLine
arrow : Arrow
wedge : Wedge
histogram : Histogram
axis : Axis, LabelFormatter, DefaultLabelFormatter, MonthLabelFormatter, LogLabelFormatter, UserLabelFormatter
box : Box
grid : Grid
label : Label

"""


from basic import Polyline, Polygon, Text, Image, Contours
from nonbasic import Line, Marker, Markers, Circle, Rectangle
from compound import MarkerLine
from arrow import Arrow
from wedge import Wedge
from histogram import Histogram
from axis import Axis, LabelFormatter, DefaultLabelFormatter, MonthLabelFormatter, LogLabelFormatter, UserLabelFormatter
from box import Box
from grid import Grid
from label import Label
from lines import Lines
from plotobject import PlotObject
