"""The base class of all plotobjects, does property checking

If a property does not exists, an exception is raised, instead of the normal
behaviour classes have, that you just add attributes


"""
from autoproperty import *
import types
from Kplot import Matrix, Color
from properties import *
class Dummy(type): pass
import inspect
from pdb import set_trace
from Numeric import ArrayType
from Kplot.tools import stripsource

class PlotObject(object):
	__metaclass__ = Dummy
	changeListeners = autoproperty()
	def __init__(self, properties, defaults = None):
		self.changeListeners = []
		if properties == None:
			properties = {}
		for key, value in properties.items():
			setattr(self, key, value)
		if defaults != None:
			for key, value in defaults.items():
				if not (key in properties) and key in self.__class__.__dict__:
					setattr(self, key, value)
		#setattr(self,"changeListener", [])




	def setDefault(cls, name, value):
		cls.__dict__[name].default = value

	setDefault = classmethod(setDefault)

	def getAttrName(self, prop):
		for key, value in self.__class__.__dict__.items():
			print key, value
			if value == prop:
				return key
		return None

	#def __setattr__(self, name, value):
	#	d = self.__dict__
	#	print d.keys()
	#	if name in dir(self.__class__):# and isinstance(d[name], autoproperty):
	#		p = getattr(self.__class__, name, self)
	#		p.__set__(self, value)
	#		#d[name].__set__(self, value)
			#setattr(self, name, value)
	#	else:
			#set_trace()
	#		raise AttributeError, name +" is no attribute, see list below\n" +self.attributes()



	def info(self):
		#print self.__class__.__name__, "properties:"
		s = ""
		s += self.__class__.__name__ +" attributes:"+"\n"
		for key, value in self.__class__.__dict__.items():
			if isinstance(value, autoproperty):
				value = value.__get__(self, self.__class__)
				if(type(value) == ArrayType):
					value = type(value)
				s += "\t" +key +"-" +str(value) +"\n"
		return s

	def printInfo(self):
		print self.info()

	def attributes(self):
		s = ""
		s += self.__class__.__name__ +" attributes:"+"\n"
		for key, value in self.__class__.__dict__.items():
			if isinstance(value, autoproperty):
				s += "\t" +key +"\n"
		return s


	def getProperties(self, exclude=[]):
		dict = {}
		for key, value in self.__class__.__dict__.items():
			if isinstance(value, autoproperty) and key not in exclude:
				dict[key] = value.__get__(self, self.__class__)
		return dict

	def examplesource(cls):
		if hasattr(cls, "example"):
			print stripsource(inspect.getsource(cls.example))
		else:
			print "no example for this PlotObject"

	def example(cls):
		print "no example for PlotObject", cls.__name__

	def testsource(cls):
		if hasattr(cls, "test"):
			print stripsource(inspect.getsource(cls.test))
		else:
			print "no test for this PlotObject"

	def test(cls):
		print "no test for PlotObject", cls.__name__

	examplesource = classmethod(examplesource)
	example = classmethod(example)

	testsource = classmethod(testsource)
	test = classmethod(test)
	
	def addChangeListener(self, listener):
		self.changeListeners.append(listener)

	def removeChangeListener(self, listener):
		self.changeListeners.remove(listener)

	def changeNotify(self):
		for listener in self.changeListeners:
			listener.changeNotify()
			
	def __repr__(self):
		return object.__repr__(self) + "\n" +self.info()


