"""Predefined typechecking properties, using internally in Kpot"""
from autoproperty import *
from Kplot import Color, Matrix

class NumberMeta(type):
	def __init__(self, name,  bases, dict):
		type.__init__(self, name, bases, dict)

	def __eq__(self, other):
		#print self, other
		return other in [types.IntType, types.FloatType, types.LongType]

class NumberType(object):
	__metaclass__ = NumberMeta

knowntypes[NumberType] = "number"
#		pointproperty()

defcolors = ["red", "green", "blue", "purple", "yellow", "orange", "grey"]
defcolorIndex = 0
def getDefaultColor():
	global defcolorIndex
	global defcolors
	color = defcolors[defcolorIndex]
	defcolorIndex = (defcolorIndex + 1) % len(defcolors)
	return color


def pointproperty(default=None, docstring=None):
	if docstring != None:
		#return autoproperty(typelist = [(NumberType, NumberType)], default=default, docstring=docstring)
		return autoproperty(default=default, docstring=docstring)
	else:
		#return autoproperty(typelist = [(NumberType, NumberType)], default=default, docstring=docstring)
		return autoproperty(default=default, docstring="""a 2 dimensional point in the form of a (x, y) tuple""")

def colorproperty(docstring=None):
	if docstring == None:
		docstring = """Color can be a Color object or a a string represeting the color

color can be a Color object:
	'color=Color(red, green, blue)' where red, green and blue are
	 floats between 0 and 1.
color can be a string:
	'color="red"', where the string is one of the following strings:
	"background", "foreground", "white", "red", "green", "blue",
	"purple", "yellow", "orange", "grey", "black"
"""
	#return autoproperty(typelist = [Color, types.StringType], default=getDefaultColor, docstring=docstring)
	return autoproperty(typelist = [Color, types.StringType], default="foreground", docstring=docstring)	

def bgcolorproperty(docstring=None):
	if docstring == None:
		docstring = """See color"""
	return autoproperty(typelist = [Color, types.StringType], default=None, docstring=docstring)

def linestyleproperty(docstring=None):
	return autoproperty(typelist = [types.StringType], default="normal", docstring=docstring)

def fillstyleproperty(docstring=None):
	return autoproperty(typelist = [types.StringType], default="solid", docstring=docstring)

def linewidthproperty(docstring=None):
	return autoproperty(typelist = [NumberType], default=0.5, docstring="""width of line specified in units""")


def fontweightproperty(docstring=None):
	if docstring == None:
		docstring = "linewidth of character outlines in units\n0 means the most thin like possible"
	return autoproperty(typelist = [NumberType], default=0, docstring=docstring)

def fontproperty(docstring=None):
	if docstring == None:
		docstring = "string representing a font"
	return autoproperty(typelist = [types.StringType], default="normal", docstring=docstring)

def fontsizeproperty(docstring=None):
	if docstring == None:
		docstring = "height of the characters in units"
	return autoproperty(typelist = [NumberType], default=12, docstring=docstring)

def matrixproperty(docstring=None):
	return autoproperty(typelist = [Matrix], default=Matrix(), docstring=docstring)

def numberproperty(default=None, docstring=None):
	return autoproperty(typelist = [NumberType], default=default, docstring=docstring)

#def rectangleproperty(default=None, docstring=None):
#	return autoproperty(typelist = [((NumberType, NumberType), (NumberType, NumberType))], docstring=docstring)

def stringproperty(default=None, docstring=None):
	return autoproperty(typelist = [types.StringType], default=default, docstring=docstring)

def arrayproperty(default=None, docstring=None):
	if docstring == None:
		docstring = "A sequence like a list or tuple"
	return autoproperty(typelist = [Numeric.ArrayType, types.ListType, types.TupleType], default=default, docstring=docstring)

def booleanproperty(default=None, docstring=None):
	if docstring == None:
		docstring = """boolean, True or False"""
	return autoproperty(default=default, docstring=docstring)

def unitsproperty():
	return stringproperty()
