import Kplot
from Numeric import *

dev = None
panel = None
line = Kplot.Polyline(x=[], y=[])
box = Kplot.Box()

def _devInit():
	global dev
	if dev == None:
		dev = Kplot.createDevice()
	dev.setAutoReplot(False)
	dev.reset()


def xyplot(expression, step=0.1, domain=(0,10), color="foreground", drawbox=True, drawgrid=True):
	global dev, panel, line, box
	_devInit()
	panel = dev.createPanel()
	x = arange(domain[0], domain[1]+step/2.0, step)
	try:
		exec "y = "+expression
	except:
		print "invalid expression"
		raise
	panel.setWorldXY(x,y, margin=0.1)
	if drawbox:
		panel.add(box)
		if not drawgrid:
			box.drawgrid = False

	line.x = x
	line.y = y
	panel.add(line)
	dev.setAutoReplot(True)
	dev.output()
	dev.setAutoReplot(True)

def parplot(xexpression, yexpression, step=0.1, domain=(0,10), color="foreground", drawbox=True, drawgrid=True):
	global dev, panel, line, box
	_devInit()
	panel = dev.createPanel()
	t = arange(domain[0], domain[1]+step/2.0, step)
	exec "x = "+xexpression
	exec "y = "+yexpression
	panel.setWorldXY(x,y)
	if drawbox:
		panel.add(box)
		if not drawgrid:
			box.drawgrid = False

	line.x = x
	line.y = y
	panel.add(line)
	dev.output()
	dev.setAutoReplot(True)
