"""Some handy functions, mainly used in Kplot itself"""
from Numeric import ArrayType
from math import pi

class AbstractException(Exception):
	pass

def abstract():
	"""Raises AbstractException"""
	raise AbstractException()

def issequence(obj):
	"""Tests if obj has the __getitem__ method or is of type ArrayType"""
	return hasattr(obj, "__getitem__") or type(obj) == ArrayType

def todegrees(radians):
	"""Convert radians to degrees"""
	return radians * 180/pi

def toradians(degrees):
	"""Convert degrees to radians"""
	return degrees * pi/180

def stripsource(source, tabs=8):
	source = source.replace("\t", " " * tabs)
	lines = source.splitlines()[1:]#("\r\n")[1:]
	minspace = max([len(k) for k in lines])
	for line in lines:
		if len(line) != 0:
			newspace = len(line) - len(line.lstrip())
			if newspace < minspace:
				minspace = newspace
	lines = map(lambda x: x[minspace:], lines)
	import string
	return string.join(lines, "\n")
