#!/usr/bin/env python2.2
import Kplot
import Numeric
from RandomArray import random
import RNG

mean = 0.0					# mean of gaussian
std = 4.0					# standard deviation
samplesize = 100000			# size of random number sample
xlow = -20.0					# start of bin
xhigh = 20.0					# end of bin
bins = 150					# number of bins

# generate random numbers
dist = RNG.NormalDistribution(mean, std)
rng = RNG.CreateGenerator(0, dist)
x = rng.sample(samplesize)

# histogram of binned data
binned = Kplot.algo.bindata(x, bins, xlow, xhigh)
maxValue = max(binned)
histogram = Kplot.Histogram(binned, fillstyle="nofill", polyline=True, color="red")

# equivalent gaussian function
xg = Numeric.arrayrange(xlow, xhigh, 0.1)
yg = Numeric.exp( (-xg*xg) / (2 * std * std)  )
line = Kplot.Polyline(xg, yg, color="blue")


dev = Kplot.createDevice()

panel = dev.createPanel()

panel.setWorld(p1=(0,0), p2=(bins, maxValue * 1.03))
panel.add(histogram)
panel.add(line)
box = Kplot.Box()
box.leftaxis.textangle = Kplot.toradians(-90)
panel.add(box)

overlay = panel.overlay(p1=(xlow,0), p2=(xhigh, 1 * 1.03))
overlay.add(line)
overlay.add(Kplot.Label("count", "left", displacement=15, color="red"))
overlay.add(Kplot.Label("x", "bottom", displacement=15, color="red"))
overlay.add(Kplot.Label("gaussian distribution", "top", color="red"))

dev.output()
dev.close()
