#!/usr/bin/env python
import Kplot
import Numeric
import math

dev = Kplot.makeDevice()

np1 = Kplot.Vector(0.1, 0.1)
np2 = Kplot.Vector(0.3, 0.3)
wp1 = Kplot.Vector(0.5, 0.15)
wp2 = Kplot.Vector(0.9, 0.55)

dp1 = Kplot.Vector(0.2, 0.60)
dp2 = Kplot.Vector(0.5, 0.90)

paneldevice = dev.getPanel(p1=dp1, p2=dp2)
panelpanel = paneldevice.getPanel(p1=(0.2, 0.2), p2=(0.5, 0.9))

panel1 = dev.getPanel(p1=(0,0), p2=(1.0, 1.0))
panelnorm = dev.getPanel(p1=np1, p2=np2)
panel2 = dev.getPanel(p1=(0,0), p2=(1.0, 1.0))
panelworld = dev.getPanel(p1=wp1, p2=wp2)
panel1.fillstyle = "nofill"
panel2.fillstyle = "nofill"

x = [0.1, 1, 0.9, 0]
y = [0, 0.1, 1, 0.9]
polygon = Kplot.Polygon(x, y, color="red")



ticks = Numeric.arange(-2, 10, 0.5)
grid = Kplot.Grid(xticks=ticks, yticks=ticks, color="white")

panelworld.setWorld(p1=(-2, -2), p2=(8,8))
label = Kplot.Label("World coordinates are mapped onto a unit square(Panel)", "top")
box = Kplot.Box(drawgrid=False)
box.grid.color = "green"
panelworld.add(grid, box, polygon, label)


label = Kplot.Label("unit square(Panel)", "top")
p1, p2 = panelworld.getWorld()
panelnorm.setWorld(p1=p1, p2=p2)
box = Kplot.Box(drawgrid=False)
panelnorm.add(grid, polygon, label)
p1, p2 = panelworld.getWorld()
panelnorm.overlay(p1=(0,0), p2=(1,1)).add(box)
box.grid.color = "green"

label = Kplot.Label("The unit square(Panel) is put onto the device", "top")
box = Kplot.Box(drawgrid=False)
paneldevice.add(label)
box.grid.color = "green"

p1, p2 = panelworld.getWorld()
panelpanel.setWorld(p1=p1, p2=p2)
panelpanel.add(grid, polygon)


linestyle = "dashed"
color = "blue"
panel2.add(Kplot.Line(p1=(np1.x, np1.y), p2=(wp1.x, wp1.y), linestyle=linestyle, color=color))
panel2.add(Kplot.Line(p1=(np2.x, np1.y), p2=(wp2.x, wp1.y), linestyle=linestyle, color=color))
panel2.add(Kplot.Line(p1=(np2.x, np2.y), p2=(wp2.x, wp2.y), linestyle=linestyle, color=color))
panel2.add(Kplot.Line(p1=(np1.x, np2.y), p2=(wp1.x, wp2.y), linestyle=linestyle, color=color))

linestyle = "dashed"
color = "green"
def line(p1, p2, frompanel, topanel, targetpanel):
	np1 = targetpanel.toWorld(frompanel.fromWorld(p1))
	np2 = targetpanel.toWorld(topanel.fromWorld(p2))
	targetpanel.add(Kplot.Line(p1=np1, p2=np2, linestyle=linestyle, color=color))

panelpanelnorm = panelpanel.overlay(p1=(0,0), p2=(1,1))
over = panelnorm.overlay(p1=(0,0), p2=(1,1))
line((0,0),(0,0), over, panelpanelnorm, panel1)
line((0,1),(0,1), over, panelpanelnorm, panel1)
line((1,0),(1,0), over, panelpanelnorm, panel1)
line((1,1),(1,1), over, panelpanelnorm, panel1)

dev.output()
dev.outputto(Kplot.pgplot.Device("coordinates.gif/GIF"))
dev.close()
