#!/usr/bin/env python

import Kplot
import fits
import sys
import Numeric
import math
from pdb import set_trace

def test(value):
	#set_trace()
	return 0.5+value
colormap = Kplot.ColorMap.rainbow
function=lambda x: math.sqrt(1-x)
#function=test#lambda x: math.sqrt(x+0.3)
data = fits.FITS(sys.argv[1]).data
sliceindex = len(data)/2 -28
dataslice = data[sliceindex]
image = Kplot.Image(data, colormap=colormap, function=function)
#simage.datamin = 9000
#image.datamax = 11000
#set_trace()
labelcolor = "blue"
scanlinecolor = "foreground"
Kplot.Text.setDefault("color", "blue")
Kplot.Axis.setDefault("color", "blue")
#print getattr(Kplot.Image, "function").default
wedge = Kplot.Wedge(image, "up")
wedge.box.leftlabeling = False
wedge.box.rightlabeling = True

normalwedge = Kplot.Wedge(Kplot.Image(data, colormap=colormap), "up")
normalwedge.box.leftlabeling = False
normalwedge.box.rightlabeling = False


dev = Kplot.makeDevice()
#dev = Kplot.pgplot.Device("exampleimage2.gif/GIF", size=(250,250))
panel = dev.getPanel()

panel.fillstyle = "nofill"
bottom, top = panel.split(0.5, "horizontal")
bottom.color = "foreground"
top.color = "foreground"

panel.add(Kplot.Label("Using sqrt(1-value) for Image.function, colormap is heat", "top"))
top.add(Kplot.Label("Image as seen in Kplot with wedge", "top"))
bottom.add(Kplot.Label("One scanline in process", "top"))
imagepanel, wedgepanel = top.split(0.7, "vertical", spacing=0)
p1 = (0.5, 0.5)
p2 = (image.getWidth() + 0.5, image.getHeight() + 0.5)
imagepanel.setWorld(p1=p1, p2=p2)
imagepanel.add(image)
imagepanel.add(Kplot.Line(p1=(0,sliceindex), p2=(image.getWidth(), sliceindex), color=scanlinecolor))
wedgepanel.add(wedge)
imagepanel.color = "black"
wedgepanel.color = "black"


slicespanel, normalwedgepanel = bottom.split(0.7, "vertical", spacing=0.0)
slicepanel, funcslicepanel = slicespanel.split(0.5, "vertical", spacing=0)

p1 = (0.0, image.datamin)
p2 = (len(dataslice), image.datamax)
slicepanel.setWorld(p1=p1, p2=p2)

p1 = (0.0, 0.0)
p2 = (len(dataslice), 1)
funcslicepanel.setWorld(p1=p1, p2=p2)
#print dataslice
slicepanel.add(Kplot.Polyline(range(len(dataslice)), dataslice, color=scanlinecolor))


#colorwidth = (self.imageColorMax - self.imageColorMin) + 1
#data = clip(data, datamin, datamax)
#scale = colorwidth / float((datamax - datamin))
#data = ((data - datamin) * scale)
scale = float((image.datamax - image.datamin)) + 1
normdataslice = (Numeric.clip(dataslice, image.datamin, image.datamax) - image.datamin)/ scale
normdataslice = map(image.function, normdataslice)
normdataslice = Numeric.clip(normdataslice, 0, 0.99)
normdataslice = normdataslice
funcdataslice = Numeric.array(normdataslice)# * 1.0

funcslicepanel.add(Kplot.Polyline(range(len(funcdataslice)), funcdataslice, color=scanlinecolor))
normalwedgepanel.add(normalwedge)
normalwedgepanel.add(Kplot.Label("original colormap", "right", alignment="top"))

slicepanel.add(Kplot.Label("original", "bottom"))
funcslicepanel.add(Kplot.Label("processed", "bottom"))
emptybox = Kplot.Box(leftlabeling=False, bottomlabeling=False, drawgrid=False)
slicepanel.add(emptybox)
funcslicepanel.add(emptybox)

slicespanel.color = "foreground"
slicepanel.color = "black"
funcslicepanel.color = "black"

dev.output()
#dev.hardcopy("exampleimage")
#gifdev1 = Kplot.pgplot.Device("exampleimage.gif/GIF", size=(250,250))
#gifdev2 = Kplot.pgplot.Device("exampleimage.ps/CPS")
#dev.outputto(gifdev2)
#dev.outputto(gifdev1)
dev.close()

